Subject: The AIPS FAQ
From: [email-masked] (Jeff Uphoff)
Date: Wed, 7 Sep 1994 18:20:16 GMT
Newsgroups: comp.os.linux.announce

Since my post here a couple of days ago about the availability of the
15JUL94 release of AIPS (and my accompanying comments for Linux), I have
received e-mail from numerous people asking, "So just what is this AIPS
thing?"

I hadn't thought about describing it at the time I was posting, and now
realize that since this isn't an AIPS-oriented group (unlike the group
that the original announcement appeared in: alt.sci.astro.aips), I
should have added a description of AIPS itself.

A general rule of thumb for AIPS is: If you don't already know what it
is, odds are you'll have no use for it; it's very well known in the
community that it's used in, and not very well-known outside of it.

Here's the AIPS FAQ, describing what AIPS is and does:

(I'll only be posting this in c.o.l.a. once--for future AIPS release
announcements I'll be just giving a short description of AIPS, as well
as directions to the WWW and text versions of the FAQ.)

------------------------------------------------------------------
The main source for this FAQ (list of Frequently Asked Questions) is AIPS
memo 87, "The NRAO AIPS Project --- A Summary" by Alan H. Bridle and Eric
W. Greisen.  This first version has only been very sketchily expanded beyond
the contents of that memo.  A hypertext (WWW) version of this document is
available via the AIPS home page (http://info.cv.nrao.edu/aips/) and a plain
text version is also available via anonymous ftp on baboon.cv.nrao.edu in
pub/aips/aips_faq.txt.

This FAQ is posted on alt.sci.astro.aips, alt.answers, and news.answers
about every four weeks.  Comments, suggestions for improvement, etc. are
welcome and should be addressed to [email-masked].
 _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

			    TABLE OF CONTENTS

   1.  WHAT IS AIPS?
   2.  WHAT IS IT USED FOR?
   3.  WHAT DOES IT RUN ON?  WHAT PERHIPHERALS DOES/CAN IT USE?
   4.  WHO USES IT?
   5.  HOW CAN I FIND OUT MORE?
   6.  HOW DO I KNOW IT WORKS, OR HOW FAST OR WELL?
   7.  WHAT OF THE FUTURE?
   8.  HOW CAN I GET IT - WHO CAN I CALL?
 _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _

1.  WHAT IS AIPS?  

    The NRAO Astronomical Image Processing System (AIPS) is a software
package for interactive (and, optionally, batch) calibration and editing
of radio interferometric data and for the calibration, construction,
display and analysis of astronomical images made from those data using
Fourier synthesis methods.  Design and development of the package began in
Charlottesville, Virginia in 1978.  It presently consists of over 800,000
lines of code, 80,000 lines of on-line documentation, and 400,000 lines of
other documentation.  It contains over 300 distinct applications "tasks,"
representing approximately 50 person-years of effort since 1978.  The AIPS
group in Charlottesville and Socorro has five full-time scientist/
programmers, and several other computing and scientific staff with partial
responsibility to the AIPS effort.  The group is responsible for the code
design and maintenance, for documentation aimed at users and programmers,
and for exporting the code to about 200+ non-NRAO sites that have requested
copies of AIPS.  It currently offers AIPS installation kits for a variety
of UNIX systems, with updates available semi-annually.

    In 1983, when AIPS was selected as the primary data reduction package
for the Very Long Baseline Array (VLBA), the scope of the AIPS effort was
expanded to embrace all stages of radio interferometric calibration, both
continuum and spectral line.  The AIPS package contains a full suite of
calibration and editing functions for both VLA and VLBI data, including
interactive and batch methods for editing visibility data.  For VLBI, it
reads data in MkII, MkIII and VLBA formats, performs global fringe-fitting
by two alternative methods, offers special phase-referencing and
polarization calibration, and performs geometric corrections, in addition
to the standard calibrations done for connected-element interferometers.
The calibration methods for both domains encourage the use of realistic
models for the calibration sources and iterated models using
self-calibration for the program sources.

2.  WHAT IS IT USED FOR?

    AIPS has been the principal tool for display and analysis of both two-
and three-dimensional radio images (i.e., continuum "maps" and
spectral-line "cubes") from the NRAO's Very Large Array (VLA) since early
in 1981.  It has also provided the main route for self-calibration and
imaging of VLA continuum and spectral-line data.  It contains facilities
for display and editing of data in the aperture, or u-v, plane; for image
construction by Fourier inversion; for deconvolution of the point source
response by Clean and by maximum entropy methods; for image combination,
filtering, and parameter estimation; and for a wide variety of TV and
graphical displays.  It records all user-generated operations and
parameters that affect the quality of the derived images, as "history"
files that are appended to the data sets and can be exported with them
from AIPS in the IAU-standard FITS (Flexible Image Transport System; see
newsgroup sci.astro.fits and http://fits.cv.nrao.edu/) format.  AIPS
implements a simple command language which is used to run "tasks" (i.e.,
separate programs) and to interact with text, graphics and image displays.
A batch mode is also available.  The package contains nearly 3.8 Mbytes of
"help" text that provides on-line documentation for users.  There is also
a suite of printed manuals for users and for programmers wishing to code
their own applications "tasks" within AIPS.

3.  WHAT DOES IT RUN ON?  WHAT PERHIPHERALS DOES/CAN IT USE?

    An important aspect of AIPS is its portability.  It has been designed
to run, with minimal modifications, in a wide variety of computing
environments.  This has been accomplished by the use of generic FORTRAN
wherever possible and by the isolation of system-dependent code into
well-defined groups of routines.  AIPS tries to present as nearly the same
interface to the user as possible when implemented in different computer
architectures and under different operating systems.  The NRAO has sought
this level of hardware and operating system independence in AIPS for two
main reasons.  The first is to ensure a growth path by allowing AIPS to
exploit computer manufacturers' advances in hardware and in compiler
technology relatively quickly, without major recoding.  (AIPS was
developed in ModComp and Vax/VMS environments with Floating Point Systems
array processors, but was migrated to vector pipeline machines in 1985.
Its portability allowed it to take prompt advantage of the new generation
of vector and vector/parallel optimizing compilers offered in 1986 by
manufacturers such as Convex and Alliant.  It was extended in simple ways
in 1992 to take full advantage of the current, highly-networked
workstation environment).  The second is to service the needs of NRAO
users in their home institutes, where available hardware and operating
systems may differ substantially from NRAO's.  By doing this, the NRAO
supports data reduction at its users' own locations, where they can work
without the deadlines and other constraints implicit in a brief visit to
an NRAO telescope site.

     The exportability of AIPS is now well exploited in the astronomical
community; the package is known to have been installed at some time on a
large number of different computers, and is currently in active use for
astronomical research at more than 140** sites worldwide.  AIPS has been
run on Cray and Fujitsu supercomputers, on Convex and Alliant "mini-
supercomputers," on the full variety of Vaxen and MicroVaxen, and on a
wide range of UNIX workstations including Apollo, Data General, Hewlett
Packard, IBM, MassComp, Nord, Silicon Graphics, Stellar and SUN products.
It is available for use on 80386 and 80486 personal computers under the
public-domain Linux operating system.  In late 1990**, the total computer
power used for AIPS was the equivalent of about 6.5 Cray X-MP processors
running full-time.

    Similarly, a wide range of digital TV devices and printer/plotters has
been supported through AIPS's "virtual device interfaces".  Support for
such peripherals is contained in well-isolated subroutines coded and
distributed by the AIPS group or by AIPS users elsewhere.  Television-like
interactive display in now provided directly on workstations using an AIPS
television emulator and X-Windows.  Hardware TV devices are no longer
common, but those used at AIPS sites have included IIS Model 70 and 75,
IVAS, AED, Apollo, Aydin, Comtal, DeAnza, Graphica, Graphics Strategies,
Grinnell, Image Analytics, Jupiter, Lexidata, Ramtek, RCI Trapix, Sigma
ARGS, Vaxstation/GPX and Vicom.  Printer/plotters include Versatec,
QMS/Talaris, Apple, Benson, CalComp, Canon, Digital Equipment, Facom,
Hewlett-Packard, Imagen, C.Itoh, Printek, Printronix and Zeta products.
Generic and color encapsulated PostScript is produced by AIPS for a wide
variety of printers and film recorders.  The standard interactive graphics
interface in AIPS is the Tektronix 4012, now normally emulated on
workstations using an AIPS program and X-Windows.

4.  WHO USES IT?

    The principal users of AIPS are VLA, VLBA, and VLBI Network observers.
A survey of AIPS sites carried out in late 1990** showed that 61% of all
AIPS data processing worldwide was devoted to VLA data reduction.  Outside
the NRAO, AIPS is extensively used for other astronomical imaging
applications, however.  56% of all AIPS processing done outside the
U.S. involved data from instruments other than the VLA.  The astronomical
applications of AIPS that do not involve radio interferometry include the
display and analysis of line and continuum data from large single-dish
radio surveys, and the processing of image data at infrared, visible,
ultraviolet and X-ray wavelengths.  About 7% of all AIPS processing
involved astronomical data at these shorter wavelengths, with 7% of the
computers in the survey using AIPS more for such work than for radio and
*another* 7% of the computers using AIPS exclusively for non-radio work.

    Some AIPS use occurs outside observational astronomy, e.g., in
visualization of numerical simulations of fluid processes, and in
medical imaging.  The distinctive features of AIPS that have attracted
users from outside the community of radio interferometrists are its
ability to handle many relevant coordinate geometries precisely, its
emphasis on display and analysis of the data in complementary Fourier
domains, the NRAO's support for exporting the package to different
computer architectures, and its extensive documentation.

5.  HOW CAN I FIND OUT MORE?

As well as producing user- and programmer-oriented manuals for AIPS, the
group publishes a newsletter that is sent to over 775 AIPS users outside
the NRAO soon after each semi-annual "release" of new AIPS code.  There is
also a mechanism whereby users can report software bugs or suggestions to
the AIPS programmers and receive written responses to them; this provides
a formal route for user feedback to the AIPS programmers and for the
programmers to document difficult points directly to individual users.
Much of the AIPS documentation is now available to the "World-Wide Web" so
that it may be examined over the Internet (start with URL
"http://info.cv.nrao.edu/aips/aips-home.html").  Also, this information is
available via anonymous ftp on baboon.cv.nrao.edu (192.33.115.103; baboon
and info are currently the same machine), directory pub/aips.  The NRAO
knows of over 230 AIPS "tasks," or programs, that have been coded within
the package outside, and not distributed by, the observatory.

6.  HOW DO I KNOW IT WORKS, OR HOW FAST OR WELL?

    The AIPS group has developed a package of benchmarking and
certification tests that process standard data sets through the dozen most
critical stages of interferometric data reduction, and compare the results
with those obtained on the NRAO's own computers.  This "DDT" (Dirty Dozen
Test) package is used to verify the correctness of the results produced by
AIPS installations at new user sites or on new types of computer, as well
as to obtain comparative timing information for different computer
architectures and configurations.  It has been extensively used as a
benchmarking package to guide computer procurements at the NRAO and
elsewhere.  Two other packages, "VLAC" and "VLAL", are less widely used to
verify the continued correctness of continuum and spectral-line
reductions.

7.  WHAT OF THE FUTURE?

     In 1992, the NRAO joined a consortium of institutions seeking to
replace all of the functionality of AIPS using modern coding techniques
and languages.  The "aips++" project is expected to provide the main
software platform supporting radio-astronomical data processing in the
latter half of the 1990's.  Future development of the original ("Classic")
AIPS will therefore be limited mostly to calibration of VLBI data, general
code maintenance with minor enhancements, and improvements in the user
documentation.

8.  HOW CAN I GET IT - WHO CAN I CALL?

    AIPS is not in the public domain.  It is proprietary software issued
to various people under a user agreement.  For academic or educational or
research oriented users, there is no charge for the agreement.  There is a
fee for commercial users.

    Why is this so?  Why does NRAO/AUI try to control distribution?  The
answer to both of these is twofold.  First, it is labelled as proprietary
code to prevent third parties from taking the code (for free), slightly
changing it, slapping a copyright on it and sueing NRAO to cease and
desist from distributing the original AIPS.  Sounds unlikely but we are
told that this sort of thing has happened to others.  Second, it is really
important to us to have a clear picture of how many users of AIPS there
are out there.  Not only does this give us a certain amount of leverage
with hardware and software vendors, but it help to justify allocation of
resources (people, computers) specifically for continued support of AIPS.

    Please do NOT try to do someone a favour by writing them a tape of
your AIPS installation.  It may seem like a friendly thing to do, but it
may end up hurting your ability (and theirs) to get technical support from
the AIPS group (see previous paragraph).  Instead, encourage your
prospective AIPS "customer" to contact us directly (see below) and
remember that the AIPS user agreement is free to the majority of potential
AIPS users.  They can get AIPS either via internet ftp (not anonymous) or
tape.

    Further information on AIPS can be obtained by writing by electronic
mail to <[email-masked]> or by paper mail to the AIPS Group, National
Radio Astronomy Observatory, Edgemont Road, Charlottesville, VA
22903-2475, U.S.A.  Use this address to request copies of AIPS or
ancillary documentation also.

[**] The 1990 AIPS Site Survey", AIPS Memo No.~70, Alan Bridle and Joanne
     Nance, April 1991
--
=============================================================================
  Patrick P. Murphy, Ph.D.                   Scientific Programming Analyst
  National Radio Astronomy Observatory                     [email-masked]
  520 Edgemont Road                                     Tel: (804) 296-0372
  Charlottesville, VA 22903-2475                        Fax: (804) 296-0278
                                         web: http://orangutan.cv.nrao.edu/
	"I don't believe in the no-win scenario"  --- James T. Kirk
=============================================================================
------------------------------------------------------------------

--
Jeff Uphoff -- "Uppie"                |  "...that sputterless little candle-
National Radio Astronomy Observatory  |  flame of the mediocre mind known as
520 Edgemont Road                     |  'common sense' has never produced
Charlottesville, VA 22903, USA        |  anything worth celebrating."
(804) 296-0208                        |    -- Tom Robbins

E-mail:  [email-masked], [email-masked]
WWW:     http://tarsier.cv.nrao.edu/~juphoff/

--
Send submissions for comp.os.linux.announce to: [email-masked]
Be sure to include Keywords: and a short description of your software.